Skip to main content

Validate token to view shared resources

POST 

/cdx/v1/shared-tokens:resources

General Availability

Validate and decrypt the shared token and view token's shared resources

Request

Responses

Consumer validates share token and view consumer resources before redeeming in the workflow

OpenAPI definition (YAML)
paths:
  /cdx/v1/shared-tokens:resources:
    post:
      description: '[![General Availability](https://img.shields.io/badge/Lifecycle%20Stage-General%20Availability-%2345c6e8)](#section/Versioning/API-Lifecycle-Policy)


        Validate and decrypt the shared token and view token''s shared resources'
      requestBody:
        content:
          application/json:
            schema:
              allOf:
              - type: object
                description: 'Encrypted Token shared with consumer



                  ## The Shared Tokens Model

                  <SchemaDefinition schemaRef="#/components/schemas/cdx.v1.SharedToken" />'
                properties:
                  metadata:
                    allOf:
                    - description: ObjectMeta is metadata that all persisted resources must have, which
                        includes all objects users must create.
                      properties: {}
                      readOnly: true
                      title: ObjectMeta
                    - properties:
                        self:
                          example: https://api.confluent.cloud/cdx/v1/shared-tokens/st-12345
                        resource_name:
                          example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/shared-token=st-12345
                  token:
                    type: string
                    description: The encrypted token
                title: cdx.v1.SharedToken
              - type: object
                required:
                - token
      x-lifecycle-stage: General Availability
      x-self-access: true
      x-name: cdx.v1.SharedToken
      operationId: resourcesCdxV1SharedToken
      tags:
      - Shared Tokens (cdx/v1)
      security:
      - cloud-api-key: []
      responses:
        '200':
          description: 'Consumer validates share token and view consumer resources before redeeming in
            the workflow

            '
          content:
            application/json:
              schema:
                type: object
                properties:
                  consumer_shared_resources:
                    type: array
                    items:
                      type: object
                      description: '`ConsumerSharedResource` object contains details of the data stream

                        (topic, schema registry subjects, sharing metadata) that you received through
                        Stream Sharing.



                        ## The Consumer Shared Resources Model

                        <SchemaDefinition schemaRef="#/components/schemas/cdx.v1.ConsumerSharedResource"
                        />'
                      properties:
                        api_version:
                          type: string
                          enum:
                          - cdx/v1
                          description: APIVersion defines the schema version of this representation of
                            a resource.
                          readOnly: true
                        kind:
                          type: string
                          description: Kind defines the object this REST resource represents.
                          readOnly: true
                          enum:
                          - ConsumerSharedResource
                        id:
                          description: ID is the "natural identifier" for an object within its scope/namespace;
                            it is normally unique across time but not space. That is, you can assume that
                            the ID will not be reclaimed and reused after an object is deleted ("time");
                            however, it may collide with IDs for other object `kinds` or objects of the
                            same `kind` within a different scope/namespace ("space").
                          type: string
                          maxLength: 255
                          readOnly: true
                          example: dlz-f3a90de
                        metadata:
                          allOf:
                          - description: ObjectMeta is metadata that all persisted resources must have,
                              which includes all objects users must create.
                            required:
                            - self
                            properties:
                              self:
                                description: Self is a Uniform Resource Locator (URL) at which an object
                                  can be addressed. This URL encodes the service location, API version,
                                  and other particulars necessary to locate the resource at a point in
                                  time
                                type: string
                                format: uri
                                readOnly: true
                                example: https://api.confluent.cloud/v2/kafka-clusters/lkc-f3a90de
                              resource_name:
                                description: Resource Name is a Uniform Resource Identifier (URI) that
                                  is globally unique across space and time. It is represented as a Confluent
                                  Resource Name
                                type: string
                                format: uri
                                readOnly: true
                                example: crn://confluent.cloud/kafka=lkc-f3a90de
                              created_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was created. It is
                                  represented in RFC3339 format and is in UTC.
                              updated_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was last updated.
                                  It is represented in RFC3339 format and is in UTC.
                              deleted_at:
                                type: string
                                format: date-time
                                example: '2006-01-02T15:04:05-07:00'
                                readOnly: true
                                description: The date and time at which this object was (or will be) deleted.
                                  It is represented in RFC3339 format and is in UTC.
                            readOnly: true
                            title: ObjectMeta
                          - properties:
                              self:
                                example: https://api.confluent.cloud/cdx/v1/consumer-shared-resources/csr-12345
                              resource_name:
                                example: crn://confluent.cloud/organization=9bb441c4-edef-46ac-8a41-c49e44a3fd9a/consumer-shared-resource=csr-12345
                        cloud:
                          type: string
                          description: The cloud service provider of the provider shared cluster.
                          example: AWS
                          x-immutable: true
                          readOnly: true
                          enum:
                          - AWS
                          - AZURE
                          - GCP
                        network_connection_types:
                          type: array
                          description: 'The network connection types of the provider shared cluster. If
                            the shared cluster is on public internet,

                            then the list will be empty

                            '
                          items:
                            type: string
                            description: Network connection type.
                            example: PRIVATELINK
                            enum:
                            - PRIVATELINK
                            title: cdx.v1.ConnectionType
                          uniqueItems: true
                          x-immutable: true
                          readOnly: true
                        display_name:
                          type: string
                          description: Consumer resource display name
                          example: Stock Trades
                          x-immutable: true
                          readOnly: true
                        description:
                          type: string
                          description: Description of consumer resource
                          example: This topic provides realtime data for the orders placed through the
                            website
                          x-immutable: true
                          readOnly: true
                        tags:
                          type: array
                          items:
                            type: string
                          description: list of tags
                          example:
                          - recent
                          - pending
                          x-immutable: true
                          readOnly: true
                        schemas:
                          type: array
                          items:
                            allOf:
                            - type: object
                              properties:
                                subject:
                                  type: string
                                  description: Name of the subject
                                  example: User
                                version:
                                  type: integer
                                  description: Version number
                                  format: int32
                                  example: 1
                                id:
                                  type: integer
                                  description: Globally unique identifier of the schema
                                  format: int32
                                  example: 100001
                                schema_type:
                                  type: string
                                  description: Schema type
                                  example: AVRO
                                schema:
                                  type: string
                                  description: Schema definition string
                                  example: '{"schema": "{"type": "string"}"}'
                              description: Schema
                              title: cdx.v1.Schema
                            - type: object
                          description: List of schemas in JSON format. This field is work in progress
                            and subject to changes.
                          x-immutable: true
                          readOnly: true
                        organization_name:
                          type: string
                          description: Shared resource's organization name
                          example: ABC Corp
                          x-immutable: true
                          readOnly: true
                        organization_description:
                          type: string
                          description: Shared resource's organization description
                          example: ABC Corp is the biggest online retailer
                          x-immutable: true
                          readOnly: true
                        organization_contact:
                          type: string
                          format: email
                          example: jane.doe@example.com
                          description: Email of the shared resource's organization contact
                          x-immutable: true
                          readOnly: true
                        logo_url:
                          type: string
                          format: uri
                          description: Resource logo url
                          example: https://confluent.cloud/api/cdx/v1/consumer-shared-resources/sr-123/images/logo
                          x-immutable: true
                          readOnly: true
                      title: cdx.v1.ConsumerSharedResource
        '400':
          description: Bad Request
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '400'
                  code: invalid_filter
                  title: Invalid Filter
                  detail: The 'delorean' resource can't be filtered by 'num_doors'
                  source:
                    parameter: num_doors
        '401':
          x-summary: Unauthorized
          description: The request lacks valid authentication credentials for this resource.
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            WWW-Authenticate:
              schema:
                type: string
              description: The unique identifier for the API request.
              example: Basic error="invalid_key", error_description="The API Key is invalid"
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '401'
                  code: user_unauthenticated
                  title: Authentication Required
                  detail: Valid authentication credentials must be provided
        '403':
          x-summary: Forbidden
          description: The access credentials were considered insufficient to grant access
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '403'
                  code: user_unauthorized
                  title: User Access Unauthorized
                  detail: The user 'mcfly' is not allowed to access the 'delorean' resource without the
                    'plutonium' role.
        '404':
          description: Not Found
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '404'
                  title: Not Found
        '409':
          x-summary: Conflict
          description: The request is in conflict with the current server state
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            Location:
              schema:
                type: string
                format: uri
                example: https://api.confluent.cloud/{object}/{id}
              description: Resource URI of conflicting resource
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '409'
                  code: resource_already_exists
                  title: Resource Already exists
                  detail: The entitlement '91e3e86f-fca6-4f14-98f5-a48e64113ce2' already exists.
        '429':
          description: Rate Limit Exceeded
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
            X-RateLimit-Limit:
              schema:
                type: integer
              description: The maximum number of requests you're permitted to make per time period.
            X-RateLimit-Remaining:
              schema:
                type: integer
              description: The number of requests remaining in the current rate limit window.
            X-RateLimit-Reset:
              schema:
                type: integer
              description: "The relative time in seconds until the current rate-limit window resets. \
                \ \n  \n**Important:** This differs from Github and Twitter's same-named header which\
                \ uses UTC epoch seconds. We use relative time to avoid client/server time synchronization\
                \ issues."
            Retry-After:
              schema:
                type: integer
              description: The number of seconds to wait until the rate limit window resets. Only sent
                when the rate limit is reached.
        '500':
          description: Oops, something went wrong!
          headers:
            X-Request-Id:
              schema:
                type: string
              description: The unique identifier for the API request.
          content:
            application/json:
              schema:
                type: object
                description: Provides information about problems encountered while performing an operation.
                required:
                - errors
                properties:
                  errors:
                    description: List of errors which caused this operation to fail
                    type: array
                    items:
                      type: object
                      description: Describes a particular error encountered while performing an operation.
                      properties:
                        id:
                          description: A unique identifier for this particular occurrence of the problem.
                          type: string
                          maxLength: 255
                        status:
                          description: The HTTP status code applicable to this problem, expressed as a
                            string value.
                          type: string
                        code:
                          description: An application-specific error code, expressed as a string value.
                          type: string
                        title:
                          description: A short, human-readable summary of the problem. It **SHOULD NOT**
                            change from occurrence to occurrence of the problem, except for purposes of
                            localization.
                          type: string
                        detail:
                          description: A human-readable explanation specific to this occurrence of the
                            problem.
                          type: string
                        source:
                          type: object
                          description: If this error was caused by a particular part of the API request,
                            the source will point to the query string parameter or request body property
                            that caused it.
                          properties:
                            pointer:
                              description: A JSON Pointer [RFC6901] to the associated entity in the request
                                document [e.g. "/spec" for a spec object, or "/spec/title" for a specific
                                field].
                              type: string
                            parameter:
                              description: A string indicating which query parameter caused the error.
                              type: string
                        error_code:
                          type: integer
                          format: int32
                        message:
                          type: string
                          nullable: true
                      additionalProperties: false
                      title: Error
                    uniqueItems: true
                title: Failure
              example:
                errors:
                - id: ed42afdc-f0d5-4c0d-b428-9fc6ed6e279d
                  status: '500'
                  code: out_of_gas
                  title: DeLorean Out Of Gas
                  detail: The DeLorean has run out of gas, but Doc Brown will fill 'er up for you asap
      servers:
      - url: https://api.confluent.cloud
        description: Confluent Cloud API
      jsonRequestBodyExample:
        token: string